// This source is subject to the Microsoft Public License.
// See http://www.microsoft.com/resources/sharedsource/licensingbasics/sharedsourcelicenses.mspx.
// All other rights reserved.

using System;

namespace QuoteAdvantage
{
	/// <summary>
	/// Exception thrown by product configuration issue
	/// </summary>
	public class ProductConfigException :  ApplicationException
	{
      private QuoteDetail objOwningProduct = null;
      private QuoteDetail objMisconfiguredItem = null;
      private string strCategoryId = "";

      public string CategoryId
      {
         get { return strCategoryId;}
         set { strCategoryId = value;}
      }
      
      public QuoteDetail OwningProduct
      {
         get { return objOwningProduct;}
         set { objOwningProduct = value;}
      }

      public QuoteDetail MisconfiguredItem
      {
         get { return objMisconfiguredItem;}
         set { objMisconfiguredItem = value;}
      }
      
      public ProductConfigException(string strMessage) : base(strMessage)
		{

      }

      public ProductConfigException(string strMessage, Exception innerException) : base(strMessage, innerException)
      {

      }
	} // end class
}
